/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.catalogos;

import java.util.HashMap;
import java.util.Map;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zhtml.Messagebox;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zk.ui.event.EventListener;
import org.zkoss.zul.Paging;
import org.zkoss.zul.Textbox;

import com.rjconsultores.ventaboletos.entidad.TipoIdentificacion;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.HibernateSearchObject;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.PagedListWrapper;
import com.rjconsultores.ventaboletos.web.utilerias.render.RenderTipoIdentificacion;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
/**
 *
 * @author Administrador
 */
@Controller("busquedaTipoDocumentoController")
@Scope("prototype")
public class BusquedaTipoDocumentoController extends MyGenericForwardComposer {

    /**
	 * 
	 */
	private static final long serialVersionUID = 4233778656660930728L;
	@Autowired
    private transient PagedListWrapper<TipoIdentificacion> plwClaseServico;
    private MyListbox tipoIdentificacionList;
    private Paging pagingTipoIdentificacion;
    private Textbox txtNome;
    private static Logger log = LogManager.getLogger(BusquedaTipoDocumentoController.class);

    public MyListbox getTipoIdentificacionList() {
        return tipoIdentificacionList;
    }

    public void setTipoIdentificacionList(MyListbox TipoIdentificacionList) {
        this.tipoIdentificacionList = TipoIdentificacionList;
    }

    public Paging getPagingTipoIdentificacion() {
        return pagingTipoIdentificacion;
    }

    public void setPagingTipoIdentificacion(Paging pagingTipoIdentificacion) {
        this.pagingTipoIdentificacion = pagingTipoIdentificacion;
    }

    public Textbox getTxtNome() {
        return txtNome;
    }

    public void setTxtNome(Textbox txtNome) {
        this.txtNome = txtNome;
    }

    @Override
    public void doAfterCompose(Component comp) throws Exception {
        super.doAfterCompose(comp);

        tipoIdentificacionList.setItemRenderer(new RenderTipoIdentificacion());
        tipoIdentificacionList.addEventListener("onDoubleClick", new EventListener() {

            @Override
            public void onEvent(Event event) throws Exception {
                TipoIdentificacion c = (TipoIdentificacion) tipoIdentificacionList.getSelected();
                verTipoIdentificacion(c);
            }
        });

        refreshLista();

        txtNome.focus();
    }

    @SuppressWarnings({ "rawtypes", "unchecked" })
	private void verTipoIdentificacion(TipoIdentificacion t) {
    	Map args = new HashMap();
        if (t != null) {
            args.put("tipoDocumento", t);
            args.put("tipoDocumentoList", tipoIdentificacionList);
        }


        openWindow("/gui/catalogos/editarTipoDocumento.zul",
                Labels.getLabel("editarTipoDocumentoController.window.title"), args, MODAL);
    }

    private void refreshLista() {
        HibernateSearchObject<TipoIdentificacion> tipoIdentificacionBusqueda =
                new HibernateSearchObject<TipoIdentificacion>(TipoIdentificacion.class,
                pagingTipoIdentificacion.getPageSize());

        tipoIdentificacionBusqueda.addFilterLike("desctipo",
                "%" + txtNome.getText().trim().concat("%"));
        tipoIdentificacionBusqueda.addFilterNotEqual("tipoIdentificacionId", -1);

        tipoIdentificacionBusqueda.addSortAsc("desctipo");
        tipoIdentificacionBusqueda.addFilterEqual("activo", Boolean.TRUE);

        plwClaseServico.init(tipoIdentificacionBusqueda, tipoIdentificacionList, pagingTipoIdentificacion);

        if (tipoIdentificacionList.getData().length == 0) {
            try {
                Messagebox.show(Labels.getLabel("MSG.ningunRegistro"),
                        Labels.getLabel("busquedaTipoIdentificacionController.window.title"),
                        Messagebox.OK, Messagebox.INFORMATION);
            } catch (InterruptedException ex) {
            	log.error("Erro ao mostrar mensagem", ex);
            }
        }
    }

    public void onClick$btnPesquisa(Event ev) {
        refreshLista();
    }

    public void onClick$btnRefresh(Event ev) {
        refreshLista();
    }

    public void onClick$btnNovo(Event ev) {
        verTipoIdentificacion(null);
    }
}
